Description

Executing some SEXTANTE vector geoprocesses a RuntimeException: Name descriptor duplicated occurs.

Example 1: "Union".
The name descriptor duplicated is GEOMETRY, because both input layers have a GEOMETRY field. (see #2849)

Example 2: "Geometric properties of polygons"
It happens only when the input layer attribute table contains at least one of the fields added by the geoalgorithm (e.g. AREA).

Related issues:
Related to Application: gvSIG desktop - gvSIG bugs # 2849: Several SEXTANTE g... Closed 10/03/2014

Associated revisions

Revision 570 - 10/16/2014 08:41 AM - Francisco Diaz Carsi

refs #2851 Arreglado para que cuando el geoproceso crea la capa temporal no tenga en cuenta las columnas de tipo GEOMETRY de las capas de
origen y cree él una unica columna de éste tipo.

Revision 100 - 10/23/2014 03:18 AM - Francisco Diaz Carsi

refs #2851 anadidos los métodos necesarios para inicializar los valores por defecto en las features (para evitar los valores nulos) y chequear y ofrecer
los nombres de los atributos para evitar duplicidades y longitud superior a 10 caracteres.

Revision 587 - 10/23/2014 03:21 AM - Francisco Diaz Carsi

refs #2851 arreglado el chequeo de los nombres de los atributos para evitar duplicidades y longitud superior a 10 caracteres.

Revision 588 - 10/23/2014 03:25 AM - Francisco Diaz Carsi

refs #2851 Sobreescritos los métodos necesarios para que los geoprocesos puedan acceder al los types y names de los atributos del featureType
como es habitual en sextante sin el atributo de geometria por defecto.

05/05/2024 1/4




Revision 115 - 10/28/2014 08:20 AM - Francisco Diaz Carsi

refs #2851 Creado el método checkAttrName en la clase ShapesTools para poder ser utilizado en el método addFields de la propia clase y también

desde la clase GeoAlgorithm.

History

#1 - 10/03/2014 05:51 AM - Antonio Falciano
I've forgotten to say that the final effect of this exception is that the "File not found" window appears. If we check for the output layer in the
tmp-andami folder we discover that it's not created at all.
#2 - 10/13/2014 07:14 AM - Alvaro Anguix
- Related to gvSIG bugs #2849: Several SEXTANTE geoprocesses don't work fine due to the GEOMETRY field added
#3 - 10/16/2014 08:48 AM - Francisco Diaz Carsi
- % Done changed from 0 to 100
- Target version set to 2.1.0-2259-rc3
- Assignee set to Francisco Diaz Carsi
- Status changed from New to Fixed
gvsig-geoprocess:r570
Se ha arreglado para que cuando el geoproceso crea la capa temporal no tenga en cuenta las columnas de tipo GEOMETRY de las capas de origen y
cree él una Unica columna de este tipo.
#4 - 10/16/2014 09:28 AM - Joaquin del Cerro Murciano
- Target version changed from 2.1.0-2259-rc3 to 2.1.0-2251-testing
#5 - 10/16/2014 09:37 AM - Antonio Falciano
Francisco Diaz wrote:
gvsig-geoprocess:r570
Se ha arreglado para que cuando el geoproceso crea la capa temporal no tenga en cuenta las columnas de tipo GEOMETRY de las capas de

origen y cree él una tnica columna de este tipo.

Thanks Francisco, | imagine that you have used the same approach of the AbstractSextanteGeoProcess class. So the Union (example 1) should
work. Instead, in reference to the case of example 2, how to manage the duplicated fields? Can we use a truncation field name mechanism like that of

"Export to" (see #2681)? Or do we let the user to rename the duplicated fields?

#6 - 10/16/2014 12:23 PM - Antonio Falciano
- Status changed from Fixed to New

SEXTANTE "Union" returns the difference between the two layers in build 2251. There's not trace of error in the gvSIG.log.
#7 - 10/17/2014 06:20 AM - Francisco Diaz Carsi
- Status changed from New to Fixed

Restablezco la tarea como arreglada. Abro otro tiquet con el problema de tu Gltimo comentario #2913.

Gracias.

#8 - 10/19/2014 06:34 PM - Alvaro Anguix

- Status changed from Fixed to Closed

#9 - 10/20/2014 02:37 AM - Antonio Falciano
- Target version changed from 2.1.0-2251-testing to 2.1.0-2259-rc3
- Status changed from Closed to New

Hi Alvaro,
if we skip the GEOMETRY field in SEXTANTE geoprocesses (see #2849), then the example 1 will works fine, instead the example 2 not because the
duplicated descriptor names are not managed yet (i.e. the issue in subject). So the ticket is still open.

#10 - 10/22/2014 11:44 AM - Francisco Diaz Carsi

- Status changed from New to In progress

#11 - 10/23/2014 04:32 AM - Francisco Diaz Carsi

- Status changed from In progress to Fixed

#12 - 10/24/2014 08:08 AM - Joaquin del Cerro Murciano
- Target version changed from 2.1.0-2259-rc3 to 2.1.0-2254-testing

#13 - 10/27/2014 04:31 AM - Antonio Falciano

- Target version changed from 2.1.0-2254-testing to 2.1.0-2259-rc3
- Status changed from Fixed to New

Same issue of RC2 in build 2254. It seems that the org.gvsig.geoprocess add-on build version is 2087 (the same of RC2) instead of 2090.

#14 - 10/27/2014 05:07 AM - Alvaro Anguix
- Status changed from New to Fixed

Hi Antonio, the bug is fixed but we don't test in build 2254. | change to fixed.

#15 - 10/27/2014 12:15 PM - Joaquin del Cerro Murciano
- Target version changed from 2.1.0-2259-rc3 to 2.1.0-2254-testing

#16 - 10/27/2014 01:11 PM - Antonio Falciano

- Target version changed from 2.1.0-2254-testing to 2.1.0-2259-rc3
- Status changed from Fixed to New
The Union (example 1) works fine now, while the example 2 not yet. It returns always: "java.lang.RuntimeException: Name descriptor AREA

duplicated.".

#17 - 10/28/2014 09:11 AM - Francisco Diaz Carsi
- Status changed from New to Fixed

Corregido.

Algunos algoritmos como el de "unién" introducian ellos mismos los nombres de las columnas en la capa resultado, y esto es lo que se habia
arreglado en el commit anterior.

Pero otros, como el de "Geometric properties of polygons", delegaban en un método estatico de la clase ShapesTools. Se ha arreglado este método
para que arregle los nombres que se vayan a introducir en la capa resultado evitando los duplicados.

Asi pues, los siguientes algoritmos (que son potencialmente conflictivos en este sentido), no deberian dar este problema en el futuro:

CostInRoutesAlgorithm
CostInRoutesAnisotropicAlgorithm
CostInRoutesAnisotropicBAlgorithm
VectorFieldCalculatorAlgorithm
VectorSplitFieldAlgorithm
ExtendLinesLayerWithGridsAlgorithm
ExtendPointsLayerWithGridsAlgorithm
GeometricPropertiesAlgorithm
GeometricPropertiesLinesAlgorithm
GeometricPropertiesLinesBAlgorithm
GridStatisticsInPolygonsAlgorithm
pointCoordinatesAlgorithm
VectorClusterAlgorithm
VectorSpatialClusterAlgorithm

#18 - 10/28/2014 10:38 AM - Antonio Falciano

- Status changed from Fixed to Closed

Just tested the fix in the new addon and it works fine. Thank you!

#19 - 11/14/2014 05:45 AM - Joaquin del Cerro Murciano
- Target version changed from 2.1.0-2259-rc3 to 2.1.0-2255-testing
